diff --git a/src/common/gui/CSwitchControl.cpp b/src/common/gui/CSwitchControl.cpp
index d52e4ed52e8..885f881544f 100644
--- a/src/common/gui/CSwitchControl.cpp
+++ b/src/common/gui/CSwitchControl.cpp
@@ -93,6 +93,7 @@ CMouseEventResult CSwitchControl::onMouseDown(CPoint& where, const CButtonState&
       value = down ? 1 : 0;
    }
 
+   value_direction = 1;
    if (listener)
       listener->valueChanged(this);
 
@@ -126,18 +127,22 @@ bool CSwitchControl::onWheel(const CPoint& where,
 
    if( wheelDistance > threshold )
    {
+      wheelDistance = 0;
       ivalue ++;
       if( ivalue >= imax )
          ivalue = 0;
+      value_direction = +1;
       if (listener)
          listener->valueChanged(this);
 
    }
    else if( wheelDistance < -threshold )
    {
+      wheelDistance = 0;
       ivalue--;
       if( ivalue < 0 )
          ivalue = imax;
+      value_direction = -1;
       if (listener)
          listener->valueChanged(this);
    }
diff --git a/src/common/gui/CSwitchControl.h b/src/common/gui/CSwitchControl.h
index 9841b2678a2..d9a24ad3d13 100644
--- a/src/common/gui/CSwitchControl.h
+++ b/src/common/gui/CSwitchControl.h
@@ -51,7 +51,7 @@ class CSwitchControl : public VSTGUI::CControl, public Surge::UI::SkinConsumingC
                 const float& distance,
                 const VSTGUI::CButtonState& buttons) override;
 
-   int ivalue = 0, imax = 0;
+   int ivalue = 0, imax = 0, value_direction = 0;
    bool is_itype = false;
    bool lookedForHover = false;
    bool doingHover = false;
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index ef21abb3091..6cbaa2234cc 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -3601,16 +3601,25 @@ void SurgeGUIEditor::valueChanged(CControl* control)
    if ((tag == f1subtypetag) || (tag == f2subtypetag))
    {
       int idx = (tag == f2subtypetag) ? 1 : 0;
-      int a = synth->storage.getPatch().scene[current_scene].filterunit[idx].subtype.val.i + 1;
+      auto csc = dynamic_cast<CSwitchControl*>(control);
+      int valdir = csc->value_direction;
+      csc->value_direction = 0;
+
+      int a = synth->storage.getPatch().scene[current_scene].filterunit[idx].subtype.val.i + valdir;
       int nn =
          fut_subcount[synth->storage.getPatch().scene[current_scene].filterunit[idx].type.val.i];
       if (a >= nn)
          a = 0;
+      if( a < 0 )
+         a = nn-1;
       synth->storage.getPatch().scene[current_scene].filterunit[idx].subtype.val.i = a;
-      if (!nn)
-         ((CSwitchControl*)control)->ivalue = 0;
-      else
-         ((CSwitchControl*)control)->ivalue = a + 1;
+      if( csc )
+      {
+         if (nn == 0)
+            csc->ivalue = 0;
+         else
+            csc->ivalue = a + 1;
+      }
       control->invalid();
       synth->switch_toggled_queued = true;
       return;
